/*
 * Copyright (c) 2012, 2016, Oracle and/or its affiliates. All rights reserved.
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
 *
 * The Universal Permissive License (UPL), Version 1.0
 *
 * Subject to the condition set forth below, permission is hereby granted to any
 * person obtaining a copy of this software, associated documentation and/or
 * data (collectively the "Software"), free of charge and under any and all
 * copyright rights in the Software, and any and all patent rights owned or
 * freely licensable by each licensor hereunder covering either (i) the
 * unmodified Software as contributed to or provided by such licensor, or (ii)
 * the Larger Works (as defined below), to deal in both
 *
 * (a) the Software, and
 *
 * (b) any piece of software and/or hardware listed in the lrgrwrks.txt file if
 * one is included with the Software each a "Larger Work" to which the Software
 * is contributed by such licensors),
 *
 * without restriction, including without limitation the rights to copy, create
 * derivative works of, display, perform, and distribute the Software and make,
 * use, sell, offer for sale, import, export, have made, and have sold the
 * Software and the Larger Work(s), and to sublicense the foregoing rights on
 * either these or other terms.
 *
 * This license is subject to the following condition:
 *
 * The above copyright notice and either this complete permission notice or at a
 * minimum a reference to the UPL must be included in all copies or substantial
 * portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

// @formatter:off

/*
 @ApiInfo(
 group="Tutorial"
 )
 */
/**
 * <h1>The Truffle Tutorial</h1>
 *
 * <div id="contents">
 *
 * Welcome to <a href="https://github.com/graalvm/truffle">Truffle</a>:
 * the Open Source framework for implementing programming languages with very high performance, Java embedding,
 * language interoperation, debugging, and general tooling support.  Truffle is part of the
 * <a href="https://github.com/graalvm/truffle">Graal Project</a>, developed and maintained by
 * <a href="http://labs.oracle.com/">Oracle Labs</a>
 * and the
 * <a href="http://www.jku.at/isse/content">Institute for System Software</a> of the
 * Johannes Kepler University Linz.
 * <p>
 * This document contains tutorial information specialized for different interests,
 * for example whether you want to run Truffle languages inside a Java application ("Embedding...")
 * or implement your own language using Truffle ("Implementing..").  We expect this collection to grow.
 * <p>
 * Tutorial Topics:
 * <ul>
 * <li>{@linkplain com.oracle.truffle.tutorial.background Truffle Background}</li>
 * <li>{@linkplain com.oracle.truffle.tutorial.embedding Embedding Truffle in Java}</li>
 * <li>Truffle language interoperation (TBD)</li>
 * <li>{@linkplain com.oracle.truffle.tutorial.newlanguage Implementing a new language with Truffle}</li>
 * <li>{@linkplain com.oracle.truffle.tutorial.sulong Implementing an LLVM-based language with Sulong}</li>
 * <li>{@linkplain com.oracle.truffle.tutorial.graal The Graal Compiler}</li>
 * </ul>
 * </div>
 * <script src="doc-files/tutorial.js"></script>
 *
 * @since 0.23
 */
package com.oracle.truffle.tutorial;
